# pset1.py

import numpy as np
import sys
sys.path.append('..')

from common.core import *
from common.audio import *
from common.writer import *
from common.gfxutil import topleft_label

# part 1a
class NoteGenerator(object):
    def __init__(self, frequency, gain, duration):
        super(NoteGenerator, self).__init__()
        pass

    def generate(self, num_frames, num_channels) :
        assert(num_channels == 1)

        # TODO: calculate the proper output and continue_flag
        output = np.zeros(num_frames)
        continue_flag = False
        return (output, continue_flag)


# part 1b
def pitch_to_frequency(n) :
    # TODO - return the proper frequency for note number n
    return 0


# part 2
# TODO - complete this class
class Mixer(object):
    def __init__(self):
        super(Mixer, self).__init__()
        # add any class members...

    def add(self, gen) :
        pass

    def remove(self, gen) :
        pass

    def set_gain(self, gain) :
        pass

    def get_gain(self) :
        return 0

    def generate(self, num_frames, num_channels) :
        output = np.zeros(num_frames * num_channels)
        return (output, True)


# part 3
# It's nice to generate the envelope with a class
# Fill in Envelope and modify NoteGenerator as needed
class Envelope(object):
    def __init__(self, decay_t, n2):
    # or, optionally, allow for attack and decay times
    # def __init__(self, attack_t, decay_t, n1, n2):
        super(Envelope, self).__init__()

    # this should return the proper envelope
    def generate(self, num_frames) :
        return np.zeros(num_frames)


# part 4: You might find it helpful to create a separate function that
# does the work of adding all the overtones together, and then returning
# that array back to NoteGenerator.



# Add stuff to this class as needed to test out parts 1-4.
# For part 5, you can either use this MainWidget or make a new class.
class MainWidget(BaseWidget) :
    def __init__(self):
        super(MainWidget, self).__init__()

        self.writer = AudioWriter('data') # for debugging audio output
        self.audio = Audio(1, self.writer.add_audio)

        self.info = topleft_label()
        self.add_widget(self.info)

    def on_update(self) :
        self.audio.on_update()
        self.info.text = 'load:%.2f' % self.audio.get_cpu_load()

    def on_key_down(self, keycode, modifiers):
        if keycode[1] == 'z':
            self.writer.toggle()

run (MainWidget)
